Bug 1155490 - [GSS] (6.4.0) Memory leak in JBoss WS CXF Client's HandlerChainSortInterceptor
Summary: [GSS] (6.4.0) Memory leak in JBoss WS CXF Client's HandlerChainSortInterceptor
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: Web Services
Version: 6.3.0
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: DR10
: EAP 6.4.0
Assignee: Alessio Soldano
QA Contact: Rostislav Svoboda
URL:
Whiteboard:
Depends On:
Blocks: 1153972 1158330
TreeView+ depends on / blocked
 
Reported: 2014-10-22 08:52 UTC by Tadayoshi Sato
Modified: 2020-12-11 11:44 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
If the JAX-WS client was implemented with one JAX-WS handler, on invoking the service port method indefinitely, it resulted in a memory leak. This issue has been fixed in this release.
Clone Of:
: 1158330 (view as bug list)
Environment:
Last Closed: 2019-08-02 07:30:50 UTC
Type: Bug


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Red Hat Issue Tracker JBWS-3847 0 Major Closed Memory leak in JBoss WS CXF Client's HandlerChainSortInterceptor 2020-08-13 01:53:55 UTC

Description Tadayoshi Sato 2014-10-22 08:52:29 UTC
Description of problem:
Platform BZ for https://issues.jboss.org/browse/JBWS-3847

HandlerChainSortInterceptor.handleMessage(Message) sorts and sets JAX-WS handlers every time it handles a SOAP message:

   public void handleMessage(Message message) throws Fault
   {
      if (binding != null) {
         @SuppressWarnings("rawtypes")
         List<Handler> list = binding.getHandlerChain();
         if (list != null && !list.isEmpty()) {
            Collections.sort(list, comparator);
            binding.setHandlerChain(list);
         }
      }
   }

However, inside the org.apache.cxf.jaxws.binding.AbstractBindingImpl and org.apache.cxf.jaxws.support.JaxWsEndpointImpl implementations the handler chain is not reset every time but piled up with interceptors, which leads to subtle but indefinite memory leak in JBoss WS CXF client.

Furthermore, org.apache.cxf.jaxws.support.JaxWsEndpointImpl holds the interceptors as a kind of java.util.concurrent.CopyOnWriteArrayList. So modifying the growing list of interceptors per each message should cause a growing performance drawback, which is also not a good implementation.

How reproducible:
100%

Steps to Reproduce:
1. Implement a JAX-WS client with one JAX-WS handler
2. Run the client invoking the service port method indefinitely


Actual results:
You'll see memory leak (= increase of memory usage).


Expected results:
Memory leak should not happen.

Comment 1 JBoss JIRA Server 2014-10-30 10:07:55 UTC
Alessio Soldano <asoldano@redhat.com> updated the status of jira JBWS-3847 to Resolved

Comment 2 Kabir Khan 2014-11-10 18:33:20 UTC
See component upgrade https://bugzilla.redhat.com/show_bug.cgi?id=1153972#c2 for explanation of why the upgrade was reverted and this BZ is set back to ASSIGNED

Comment 3 Jan Blizňák 2014-11-20 17:04:45 UTC
Verified on 6.4.0.DR10

Comment 4 JBoss JIRA Server 2015-04-25 20:26:40 UTC
Alessio Soldano <asoldano@redhat.com> updated the status of jira JBWS-3847 to Closed


Note You need to log in before you can comment on or make changes to this bug.